#include "Cvor.h"
#include "Mreza.h"


Cvor::Cvor(int ident, Mreza* m)
{
	prvi=tek=posl=0;					// prilikom samog kreiranja cvora on sam nema veze ni sa jednim drugim cvorom
	id=ident;
	mreza = m;
}
int Cvor::identitet()
{
	return id;
}
int Cvor::susedni(int i)
{
	int j=0;
	tek=prvi;
	while(j<i && tek)
	{
		j++;
		tek=tek->sled;
	}
	if(tek)
	{
		return tek->l->sused(id);		// poziva id suseda na tekucem linku (linku rednog broja i)
	}
	return -1;
}
bool Cvor::prvoeraVeze(int i, int f)	// vraca true ako je konekcija na i-toj vezi i frekvenciji f moguca
{
	int a=susedni(i);
	if(a!=-1)
	{
		if(tek->l->frekvencija(f)) return true;
	}
	return false;
}
void Cvor::dodaj(Link& link)
{
	if(prvi!=0)
	{
		posl->sled=new ElemL(link);						// dodaje link koji mu je prosledjen u svoju listu na poslednje mesto
		posl=posl->sled;
	}else
	{
		prvi=new ElemL(link);					// dodaje link koji mu je proslednjen na prvo mesto u listi
		posl=prvi;
	}
}
void Cvor::dodaj(Cvor *c, int k)
{
	if(prvi)
	{
		Link* nov = new Link(id,c->identitet(), k);			// pravi se novi link prosledivsi mu kao argumente svoj id i id cvora koji se povezuje preko tog linka
		mreza->DodajLink(nov);
		c->dodaj(*nov);							// prosledjuje drugom cvoru kreirani link kako bi i drugi cvor dodao ovaj u listu veza
		posl->sled=new ElemL(*nov);				// postavlja novi link na poslednje mesto u listi linkova
		posl=posl->sled;						// pomera pokazivac na poslednji link
	}
	else
	{
		Link* nov = new Link(id, c->identitet(), k);
		c->dodaj(*nov);
		mreza->DodajLink(nov);
		prvi=new ElemL(*nov);					// razlika je samo u toliko sto prvi pokazuje na novi link
		posl=prvi;								// stavlja pokazivace prvi i poslednji na isti elemt (jedini u listi)
	}
}
void Cvor::skidaj(Link& link)
{
	ElemL* prethodni = 0;
	ElemL* temp = prvi;
	
	while (temp != 0)
	{
		if (temp->l == &link)
		{
			if (prethodni == 0)
			{
				// Ako je prvi link taj koji treba da se ukine, samo se prebaci pokazivac na sledeci
				prvi = temp->sled;
			}
			else
			{
				prethodni->sled = temp->sled;
			}

			return;
		}
		else
		{
			prethodni = temp;
			temp = temp->sled;
		}
	}
}
bool Cvor::povezan(Cvor *c)
{
	tek=prvi;
	while(tek)
	{
		if(tek->l->sused(id)==c->identitet())
		{
				return true;								// ukoliko je pronadjen cvor sa trazenim identitetom vracamo true vrednost
		}
		tek=tek->sled;
	}
	return false;											// trazenog cvora nema u listi tako da vracamo false vrednsot
}
void Cvor::zauzmiF(int f)
{
	int i=0;
	while(susedni(i)!=-1)
	{
		tek->l->zuzmiF(f);
		i++;
	}
}
void Cvor::oslobodiF(int f)
{
	int i=0;
	while(susedni(i)!=-1)
	{
		tek->l->oslobodiF(f);
		i++;
	}
}
int Cvor::povezanNa(Cvor *c)
{
	int i=0;
	if(!(this->povezan(c)))								// ispituje da li su cvor i trazeni cvor povezani
	{
		return -1;										// ukoliko nisu vrati -1
	}
	else												// ukoliko su povezani
	{
		tek=prvi;
		while(this->susedni(i)!=c->identitet())			//za svaki link cvora koji trazi vezu proveravamo da li smo nasli trazenu vezu
		{
			i++;
		}
		return i;										// vracamo redni broj linka koji povezuje ova dva cvora za cvor koji je pozvao proveru
	}
}
Cvor::~Cvor(void)
{
}
