#pragma once
#include "Link.h"
class Mreza;									// samo deklaracija klase mreza
class Cvor
{
	struct ElemL								// lista linkova povezana na dati cvor
	{
		Link *l;
		ElemL *sled;
		ElemL(Link& link)
		{
			l=&link;
			sled = 0;
		}
	};

	int id;										// identifikacija cvora
	ElemL *prvi, *tek, *posl;
	Mreza* mreza;
public:

	Cvor(int ident, Mreza *m);

	int identitet();				// vraca broj svog identieta

	int susedni(int i);				// vraca id cvora na i-toj vezi, -1 ako nema toliko veza
	
	bool prvoeraVeze(int i, int f);	// vraca true ako je konekcija na i-toj vezi i frekvenciji f moguca 

	void dodaj(Cvor *c, int k);		// ostvaruje vezu sa drugim cvorom, prosledjenim u argumentu

	void dodaj (Link& link);		// ostvaruje vezu sa drugim cvorem, preko prosledjenog linka u argumentu

	void skidaj(Link& link);		// brise vezu sa drugim cvorem, preko prosledjenog linka u argumentu

	bool povezan(Cvor *c);			// vraca true vrednost ako cvor, prosledjen kao argument ima ostvarenu vezu sa cvorem koji ispituje vezanost

	int povezanNa(Cvor *c);			// vraca interni broj linka preko kojeg je cvor povezan sa cvorem c, -1 ako nisu povezani

	void zauzmiF(int f);			// zadatu frekvenciju na svim linkovima vezanim za cvor

	void oslobodiF(int f);			// oslobadja frekvenciju na svim linkovima vezanim za cvor


	~Cvor();
};

