#pragma once
#include "Cvor.h"
#include "Red.h"
#include <iostream>

using namespace std;

class Mreza
{
	struct ElemC				//pomocna sturktura za cuvanje spiska cvorova
{
	Cvor *p;
	ElemC *sled;

	ElemC(Cvor *c)
	{
		p = c;
		sled = 0;
	}
	~ElemC()
	{
		delete p;
		p = 0;
	}
};

struct ElemL					//pomocna sturktura za cuvanje spiska linkova
{
	Link *p;
	ElemL *sled;

	ElemL(Link *l)
	{
		p = l;
		sled = 0;
	}
	~ElemL()
	{
		delete p;
		p = 0;
	}
};
struct ElemV					//pomocna sturktura za cuvanje spiska ostvarenih veza
{
	Red *r;
	int c1, c2, f;
	ElemV *sled;

	ElemV(Red *st)
	{
		c1=c2=f=0;
		r = st;
		sled = 0;
	}
	void postavi(int poc,int kraj, int kanal)
	{
		c1=poc;
		c2=kraj;
		f=kanal;
	}
	~ElemV()
	{
		delete r;
		r = 0;
	}
};

	ElemC *listaC, *poslC;				// prvi i poslednji cvor u spisku cvorova

	ElemL *listaL;						// pokazivac na prvu u spisku linkova

	ElemV *veze;						// pokazivac na prvu u spusku ostvarenih veza
	int brC, brL, opseg, uspK, neK;		// broj cvorova, broj linkova, broj razlicitih frekfencija na linkovima, uspeno ostvarene konekcije i
										// neuspesno ostvarene konekcije za koje je poslat zahtev

public:
	Mreza(int bc, int bl, int ops);		// inicijalizuje mrezu tj. pravi cvorove i linkove u skladu sa zadatim brojem i odabira porgodnu topologiju

	Cvor& pronadjiC(int id);			// Pronalazi cvor sa zadatim identitetom i vraca njegovu adresu (referencu)

	void zvedasta();					// Povezuje linkove i cvorove u zvezdastu topologiju

	void prstenasta();					// Povezuje linkove i cvorove u prstenastu topologiju

	void DodajLink(Link* l);			// dodaje vec postojaci link u spisak linkova

//---------------------------Sledece funkcije koriste se za resenje drugog i treceg zadatka

	int prohodnost(int id1, int id2);	// vraca frekfenciju na kojoj je moguce uspostaviti vezu izmedju cvora 1 i cvora 2 ili -1 ukoliko
										// ne moze da se ostvari veza ni na jednoj frekfenciji izmedju ova dva cvora
	// koristi se samo za testiranje funkcije prohodnost u drugom zadatku
	void zauzetost(int proc);			// za sve cvorove u topologiji proverava vrednoscu p1 zauzima slucajno odabranu frekvenciju

//---------------------------Sledece funkcije se koriste za resenje treceg zadataka

	void zauzmi(int proc);				// obilazi sve cvorove u mrezi i za svaki verovatnocom p1 pokusava da uspostavi konekciju sa slucajno odabranim cvorem
										// ukoliko ova dva cvora vec nisu u vezi
	void DodajVezu(Red *r, int a, int b, int f);// dodaje uspesno ostvarenu vezu u spisak do sad ostvarenih veza

	void PrekidVeza(int proc);			// prolazi kroz sve ostvarene veze i u skladu sa verovatnocom P2 odlucuje da li veza treba da bude prekinuta 

	void Mreza::oslobodi(ElemV *v);		// omogucuje uklanjanje veze

	void konektuj(int c1, int c2, int f);	// obezbedjuje zauzetos frekfencije f na putu izmedju cvorova c1 i c2

//	void putanja(int c1, int c2, int f,int *put);	// pravi spisak cvorova koji omogucavaju vezu izmedju cvorova c1 i c2 na frekfenciji f

	void statistika();					// ispisuje broj uspesno realizovanih konekcija i broj neuspesno realizovanih konekcija

	int najblizi(int id1, int id2, int f);  // trazi najblizi cvor cvoru id2 i na putanji id1 id2 i frekvenciji f, i vraca id cvora koji je povezan sa id2 i
											// ima slobodnu frekvenciju f

	~Mreza(void);
};

